<!-- BEGIN HEADER -->
# NConvex&ensp;<sup><sup>[![View code][code-img]][code-url]</sup></sup>

### A Gap package to perform polyhedral computations

| Documentation | Latest Release | Build Status | Code Coverage |
| ------------- | -------------- | ------------ | ------------- |
| [![HTML stable documentation][html-img]][html-url] [![PDF stable documentation][pdf-img]][pdf-url] | [![version][version-img]][version-url] [![date][date-img]][date-url] | [![Build Status][tests-img]][tests-url] | [![Code Coverage][codecov-img]][codecov-url] |

<!-- END HEADER -->
[![Build Status](https://travis-ci.com/homalg-project/NConvex.svg?branch=master)](https://travis-ci.com/homalg-project/NConvex)
[![Code Coverage](https://codecov.io/github/homalg-project/NConvex/coverage.svg?branch=master&token=)](https://codecov.io/gh/homalg-project/NConvex)

Introduction
------------
The [NConvex](https://homalg-project.github.io/NConvex) package is a GAP package. Its aim is to carry out polyhedral constructions and computations, namely computing properties and attributes of
cones, polyhedrons, polytopes and fans. Its has been written to provide the needed tools for the package [ToricVarieties](https://github.com/homalg-project/ToricVarieties_project/tree/master/ToricVarieties).

<!-- BEGIN FOOTER -->
---

### Dependencies

To obtain current versions of all dependencies, `git clone` (or `git pull` to update) the following repositories:

|    | Repository | git URL |
|--- | ---------- | ------- |
| 1. | [**homalg_project**](https://github.com/homalg-project/homalg_project#readme) | https://github.com/homalg-project/homalg_project.git |
| 2. | [**CddInterface**](https://github.com/homalg-project/CddInterface#readme) | https://github.com/homalg-project/CddInterface.git |
| 3. | [**NormalizInterface**](https://github.com/gap-packages/NormalizInterface#readme) | https://github.com/gap-packages/NormalizInterface.git |

[html-img]: https://img.shields.io/badge/🔗%20HTML-stable-blue.svg
[html-url]: https://homalg-project.github.io/NConvex/doc/chap0_mj.html

[pdf-img]: https://img.shields.io/badge/🔗%20PDF-stable-blue.svg
[pdf-url]: https://homalg-project.github.io/NConvex/download_pdf.html

[version-img]: https://img.shields.io/endpoint?url=https://homalg-project.github.io/NConvex/badge_version.json&label=🔗%20version&color=yellow
[version-url]: https://homalg-project.github.io/NConvex/view_release.html

[date-img]: https://img.shields.io/endpoint?url=https://homalg-project.github.io/NConvex/badge_date.json&label=🔗%20released%20on&color=yellow
[date-url]: https://homalg-project.github.io/NConvex/view_release.html

[tests-img]: https://github.com/homalg-project/NConvex/actions/workflows/Tests.yml/badge.svg?branch=master
[tests-url]: https://github.com/homalg-project/NConvex/actions/workflows/Tests.yml?query=branch%3Amaster

[codecov-img]: https://codecov.io/gh/homalg-project/NConvex/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/homalg-project/NConvex

[code-img]: https://img.shields.io/badge/-View%20code-blue?logo=github
[code-url]: https://github.com/homalg-project/NConvex#top
<!-- END FOOTER -->
